# 4.5.1

Release date: `2021-01-28`

## Core

- [NXDRIVE-1768](https://jira.nuxeo.com/browse/NXDRIVE-1768): Use positional-only parameters
- [NXDRIVE-2402](https://jira.nuxeo.com/browse/NXDRIVE-2402): Enable the boto3 integration into Sentry
- [NXDRIVE-2444](https://jira.nuxeo.com/browse/NXDRIVE-2444): Use Qt scoped enums
- [NXDRIVE-2459](https://jira.nuxeo.com/browse/NXDRIVE-2459): Move PyQt imports to one file
- [NXDRIVE-2472](https://jira.nuxeo.com/browse/NXDRIVE-2472): Fix a security issue when retrieving a SSL certificate
- [NXDRIVE-2482](https://jira.nuxeo.com/browse/NXDRIVE-2482): Prevent upgrading from Windows 7
- [NXDRIVE-2485](https://jira.nuxeo.com/browse/NXDRIVE-2485): Use `os.path.realpath()` instead of `abspath()`
- [NXDRIVE-2489](https://jira.nuxeo.com/browse/NXDRIVE-2489): [Windows] Subfolder content not synced on unfiltering

### Direct Edit

- [NXDRIVE-2409](https://jira.nuxeo.com/browse/NXDRIVE-2409): Handle document unlock error when it is already locked by someone else
- [NXDRIVE-2410](https://jira.nuxeo.com/browse/NXDRIVE-2410): Better server URL comparison
- [NXDRIVE-2497](https://jira.nuxeo.com/browse/NXDRIVE-2497): Fix removal of disappeared temporary downloaded file

### Direct Transfer

- [NXDRIVE-2329](https://jira.nuxeo.com/browse/NXDRIVE-2329): Add a button to create a folder within the upload flow
- [NXDRIVE-2394](https://jira.nuxeo.com/browse/NXDRIVE-2394): Handle multiple transfers on same file
- [NXDRIVE-2438](https://jira.nuxeo.com/browse/NXDRIVE-2438): Cancel folder transfer when selecting a folder with the same name
- [NXDRIVE-2453](https://jira.nuxeo.com/browse/NXDRIVE-2453): Missing label on the active sessions list
- [NXDRIVE-2480](https://jira.nuxeo.com/browse/NXDRIVE-2480): Add an information icon in options
- [NXDRIVE-2481](https://jira.nuxeo.com/browse/NXDRIVE-2481): Remove the beta label

## GUI

- [NXDRIVE-2413](https://jira.nuxeo.com/browse/NXDRIVE-2413): Refresh the GUI after a feature state has changed

## Packaging / Build

- [NXDRIVE-2400](https://jira.nuxeo.com/browse/NXDRIVE-2400): Enable back GNU/Linux releases
- [NXDRIVE-2468](https://jira.nuxeo.com/browse/NXDRIVE-2468): Fix the deploy script when a release is missing

## Tests

- [NXDRIVE-2456](https://jira.nuxeo.com/browse/NXDRIVE-2456): Remove deprecated usage of `--strict` pytest argument
- [NXDRIVE-2477](https://jira.nuxeo.com/browse/NXDRIVE-2477): Use the Python minor version in GitHub workflows
- [NXDRIVE-2503](https://jira.nuxeo.com/browse/NXDRIVE-2503): Skip errors happening at the end of tests

## Minor Changes

- Upgraded `chardet` from 3.0.4 to 4.0.0
- Upgraded `psutil` from 5.7.3 to 5.8.0
- Upgraded `pyinstaller` from 4.1 to 4.2
- Upgraded `pyinstaller-hooks-contrib` from 2020.10 to 2020.11
- Upgraded `pyobjc-core` from 7.0.1 to 7.1
- Upgraded `pyobjc-framework-cocoa` from 7.0.1 to 7.1
- Upgraded `pyobjc-framework-coreservices` from 7.0.1 to 7.1
- Upgraded `pyobjc-framework-fsevents` from 7.0.1 to 7.1
- Upgraded `pyobjc-framework-scriptingbridge` from 7.0.1 to 7.1
- Upgraded `pyobjc-framework-systemconfiguration` from 7.0.1 to 7.1
- Upgraded `pyqt5` from 5.15.1 to 5.15.2
- Upgraded `requests` from 2.25.0 to 2.25.1
- Upgraded `s3transfer` from 0.3.3 to 0.3.4
- Upgraded `tld` from 0.12.2 to 0.12.5

## Technical Changes

Warning: a lof of signature changes due to [NXDRIVE-1768](https://jira.nuxeo.com/browse/NXDRIVE-1768) are not listed here.

- Added `ActiveSessionModel.count_no_shadow()`
- Added `Application.auto_update_feature_model`
- Added `Application.direct_edit_feature_model`
- Added `Application.direct_transfer_feature_model`
- Added `execute` keyword argument to `Application.display_warning()`
- Added `Application.folder_duplicate_warning()`
- Removed `DirectTransferUploader.exists()`. Use `Remote.exists_in_parent()` instead.
- Removed `DirectTransferUploader.upload_folder()`. Use `Remote.upload_folder()` instead.
- Added `remote_parent_title` argument to `Engine.direct_transfer()`
- Added `new_folder` keyword argument to `Engine.direct_transfer()`
- Added `new_folder` keyword argument to `Engine.direct_transfer_async()`
- Added `remote_parent_title` argument to `Engine.direct_transfer_async()`
- Changed `local_parent_path` argument type of `EngineDAO.update_remote_parent_path_dt()` from `str` to `Path`
- Added `doc_pair` keyword argument to `FileAction.__init__()`
- Added `FoldersDialog.remote_folder_title`
- Added `FoldersDialog.CSS`
- Added `FoldersDialog.CSS_DISABLED`
- Added `doc_pair` keyword argument to `LinkingAction.__init__()`
- Added `Manager.featureUpdate`
- Added `Remote.exists_in_parent()`
- Added `Remote.upload_folder()`
- Added `doc_pair` argument to `UploadAction.__init__()`
- Added constants.py::`INVALID_CHARS `
- Added folders_dialog.py::`regexp_validator()`
- Added `qt/`
- Added view.py::`FeatureModel`
